'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAce = require('react-ace');

var _reactAce2 = _interopRequireDefault(_reactAce);

var _Preview = require('./Preview.css');

var _Preview2 = _interopRequireDefault(_Preview);

require('brace/mode/batchfile');

require('brace/mode/css');

require('brace/mode/html');

require('brace/mode/javascript');

require('brace/mode/json');

require('brace/mode/jsx');

require('brace/mode/markdown');

require('brace/mode/php');

require('brace/mode/sh');

require('brace/mode/text');

require('brace/theme/github');

require('brace/theme/monokai');

require('brace/theme/terminal');

require('brace/theme/tomorrow');

var _config = require('./config');

var _createHighlightMarkers = require('./createHighlightMarkers');

var _createHighlightMarkers2 = _interopRequireDefault(_createHighlightMarkers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-enable import/no-unassigned-import */

/* eslint-disable import/no-unassigned-import */
function getLanguageTitle(value) {
  const found = _config.SUPPORTED_LANGUAGES.find(lang => lang.value === value);
  return found ? found.title : null;
}

class CodePreview extends _react.PureComponent {

  render() {
    const layout = this.props.layout;

    return layout === 'block' ? this.renderBlockPreview() : this.renderDefaultPreview();
  }

  renderDefaultPreview() {
    const value = this.props.value;

    return _react2.default.createElement(
      'div',
      { className: _Preview2.default.defaultPreviewContainer },
      _react2.default.createElement(
        'div',
        null,
        value && value.language ? getLanguageTitle(value.language) : 'Unknown language'
      )
    );
  }
  renderBlockPreview() {
    var _props = this.props;
    const value = _props.value,
          type = _props.type;

    const fixedLanguage = (0, _get3.default)(type, 'options.language');
    return _react2.default.createElement(
      'div',
      { className: _Preview2.default.root },
      _react2.default.createElement(
        'h3',
        null,
        value && getLanguageTitle(value.language)
      ),
      _react2.default.createElement(
        'div',
        { className: _Preview2.default.aceWrapper },
        _react2.default.createElement(_reactAce2.default, {
          mode: value && value.language || fixedLanguage || 'text',
          theme: 'monokai',
          width: '100%',
          height: null,
          maxLines: 200,
          readOnly: true,
          wrapEnabled: true,
          showPrintMargin: false,
          highlightActiveLine: false,
          cursorStart: -1,
          value: value && value.code || '',
          markers: value && value.highlightedLines ? (0, _createHighlightMarkers2.default)(value.highlightedLines) : null,
          onLoad: this.handleEditorLoad,
          tabSize: 2,
          showGutter: false,
          setOptions: _config.ACE_SET_OPTIONS,
          editorProps: _config.ACE_EDITOR_PROPS
        })
      )
    );
  }
}
exports.default = CodePreview;
CodePreview.propTypes = {
  type: _propTypes2.default.object,
  layout: _propTypes2.default.string,
  value: _propTypes2.default.shape({
    _type: _propTypes2.default.string,
    code: _propTypes2.default.string,
    language: _propTypes2.default.string,
    highlightedLines: _propTypes2.default.array
  })
};